#!/usr/bin/perl

use strict;
use Test::More;
use FDN::Common::Config;

my $nbtest;
BEGIN { $nbtest += 1; }
my $res;
$FDN::Common::Config::CONFIG_ROOT = './t/';

my $dd = FDN::Etebac::Sepa::dd_init_file('essai', '2012-01-01');
is ( ref($dd), 'HASH', 'dd_init_file' );
BEGIN { $nbtest += 1; }

my $prllig = {
	'PRLLIGSEPA_ID' => 12,
	'PRLLIGSEPA_MONTANT' => 1,
	'PRLLIGSEPA_LIBELLE' => 'Un essai',
	'PRLLIGSEPA_BIC' => 'BNPAFRPP',
	'PRLLIGSEPA_IBAN' => 'FR7630004021950000024677491',
	'PRLLIGSEPA_MANDAT' => '++RUM-FDN-TEST',
	'PRLLIGSEPA_DATEMANDAT' => '2010-01-01',
	'PRLLIGSEPA_TITULAIRE' => 'Compte de test'
};
$res = FDN::Etebac::Sepa::dd_add_line($dd,'FRST',$prllig);
is ( ref($dd->{'FRST'}), 'ARRAY', 'dd_add_line' );
is ( scalar(@{$dd->{'FRST'}}), 1, 'dd_add_line' );
$res = FDN::Etebac::Sepa::dd_add_line($dd,'RCUR',$prllig);
is ( ref($dd->{'RCUR'}), 'ARRAY', 'dd_add_line' );
$res = FDN::Etebac::Sepa::dd_add_line($dd,'RCUR',$prllig);
is ( scalar(@{$dd->{'RCUR'}}), 2, 'dd_add_line' );
BEGIN { $nbtest += 4; }

my $file = '/tmp/test-sepa.xml';
if ( -e $file ) {
	unlink($file);
}
if ( -e $file ) {
	die "Failed to erase file '$file', cannot test.";
}

dd_make_file($dd, $file);
ok ( -e $file, 'dd_make_file' );
my $res = `xmlstarlet val -s dtd/pain.008.001.02.xsd -e $file`;
ok ( $res =~ /\bvalid\b/, 'dd_make_file' );
BEGIN { $nbtest += 2; }


BEGIN { plan tests => $nbtest; }
BEGIN { use_ok('FDN::Etebac::Sepa'); }

